#include <math.h>
#include <stdio.h>
#include <inttypes.h>

#define PI atan2 (0.0, -1.0)

const double d = 4.0;

#include "ball.h"

int main () {
    int i, frame;
    double deg_x = 0.0;
    double deg_y = 0.0;
    double deg_z = 0.0;

    double t_x[num_vertices];
    double t_y[num_vertices];

    double x, y, z;
    double x_, y_, z_;

    double sam;

    int max_frames = 128;

    int saved;
    int y_min, k;

    int sx[4];
    int sy[4];

    for (frame = 0; frame < max_frames; frame++) {

        deg_x = 2 * PI / (double)max_frames * frame * 3.0;
        deg_y = 2 * PI / (double)max_frames * frame * 2.0;
        deg_z = 2 * PI / (double)max_frames * frame * 1.0;

        for (i = 0; i < num_vertices; i++) {
            //rotate this shit
            x_ = vertx[i] * cosf(deg_z) - verty[i] * sinf(deg_z);
            y_ = vertx[i] * sinf(deg_z) + verty[i] * cosf(deg_z);

            x = x_;
            y = y_;

            y_ = y * cosf(deg_y) - vertz[i] * sinf(deg_y);
            z_ = y * sinf(deg_y) + vertz[i] * cosf(deg_y);

            y = y_;
            z = z_;

            x_ = z * sinf(deg_x) + x * cosf(deg_x);
            z_ = z * cosf(deg_x) - x * sinf(deg_x);

            //perspective
            t_x[i] = (x_ / (1.0 + z_ / d)) * scaling + 64.0;
            t_y[i] = (y_ / (1.0 + z_ / d)) * scaling + 64.0;
        }

        for (i = 0; i < num_faces; i++) {
            //culling via signed area
            sam = (t_y[faces[i][1]] - t_y[faces[i][0]]) * (t_x[faces[i][2]] - t_x[faces[i][1]]) - (t_x[faces[i][1]] - t_x[faces[i][0]]) * (t_y[faces[i][2]] - t_y[faces[i][1]]);
            if(sam > 0) {
                y_min = 0;
                for (k = 0; k < 4; k++) {
                    if (t_y[faces[i][y_min]] >= t_y[faces[i][k]] ) y_min = k;
                }

                //face to be drawn change clockwiseness
                sx[0] = t_x[faces[i][(y_min + 0) & 3]];
                sx[1] = t_x[faces[i][(y_min + 3) & 3]];
                sx[2] = t_x[faces[i][(y_min + 2) & 3]];
                sx[3] = t_x[faces[i][(y_min + 1) & 3]];

                sy[0] = t_y[faces[i][(y_min + 0) & 3]];
                sy[1] = t_y[faces[i][(y_min + 3) & 3]];
                sy[2] = t_y[faces[i][(y_min + 2) & 3]];
                sy[3] = t_y[faces[i][(y_min + 1) & 3]];

                saved = 0;
                if (sx[0] == sx[3] && sy[0] == sy[3]) saved++;
                if (sx[3] == sx[2] && sy[3] == sy[2]) saved++;
                if (sx[2] == sx[1] && sy[2] == sy[1]) saved++;
                if (sx[1] == sx[0] && sy[1] == sy[0]) saved++;

                if (saved <= 1) {
                    if ((sx[3] == sx[2] && sy[3] == sy[2]) || (sx[0] == sx[3] && sy[0] == sy[3])) printf("!byte $%02x,$%02x,$%02x,$%02x,$%02x,$%02x\n",             sx[0]|0x80, sy[0], sx[2], sy[2], sx[1], sy[1]);
                    else if (sx[2] == sx[1] && sy[2] == sy[1])                                    printf("!byte $%02x,$%02x,$%02x,$%02x,$%02x,$%02x\n",             sx[0]|0x80, sy[0], sx[3], sy[3], sx[1], sy[1]);
                    else if (sx[1] == sx[0] && sy[1] == sy[0])                                    printf("!byte $%02x,$%02x,$%02x,$%02x,$%02x,$%02x\n",             sx[0]|0x80, sy[0], sx[3], sy[3], sx[2], sy[2]);
                    else                                                                          printf("!byte $%02x,$%02x,$%02x,$%02x,$%02x,$%02x,$%02x,$%02x\n", sx[0]|0x80, sy[0], sx[3], sy[3], sx[2], sy[2], sx[1], sy[1]);
                }
            }
        }
        printf("!byte $ff\n");
    }
    return 0;
}
